HTTP Cache Groups
Internet-Draft draft-ietf-httpbis-cache-groups-02
Mark Nottingham
Prahran
Australia
mnot@mnot.net
https://www.mnot.net/
Internet-Draft
This specification introduces a means of describing the relationships between stored responses in HTTP caches, "grouping" them by associating a stored response with one or more opaque strings.
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-httpbis-cache-groups/.
Discussion of this document takes place on the HTTP Working Group mailing list (mailto:ietf-http-wg@w3.org), which is archived at https://lists.w3.org/Archives/Public/ietf-http-wg/. Working Group information can be found at https://httpwg.org/.
Source for this draft and an issue tracker can be found at https://github.com/httpwg/http-extensions/labels/cache-groups.
Introduction
HTTP caching [HTTP-CACHING] operates at the granularity of a single resource; the freshness of one stored response does not affect that of others. This granularity can make caching more efficient -- for example, when a page is composed of many assets that have different requirements for caching.
However, there are also cases where the relationship between stored responses could be used to improve cache efficiency.
For example, it is often necessary to invalidate a set of related resources. This might be because a state-changing request has side effects on other resources, or it might be purely for administrative convenience (e.g., "invalidate this part of the site"). Grouping responses together provides a dedicated way to express these relationships, instead of relying on things like URL structure.
In addition to sharing invalidation events, the relationships indicated by grouping can also be used by caches to optimise their operation; for example, it could be used to inform the operation of cache eviction algorithms.
Section 2 introduces a means of describing the relationships between a set of stored responses in HTTP caches by associating them with one or more opaque strings. It also describes how caches can use that information to apply invalidation events to members of a group.
Section 3 introduces one new source of such events: a HTTP response header that allows a state-changing response to trigger a group invalidation.
These mechanisms operate within a single cache, across the stored responses associated with a single origin server. They do not address this issues of synchronising state between multiple caches (e.g., in a hierarchy or mesh), nor do they facilitate association of stored responses from disparate origins.
Notational Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
This specification uses the following terminology from [STRUCTURED-FIELDS]: List, String, Parameter.
The Cache-Groups Response Header Field
The Cache-Groups HTTP Response Header is a List of Strings [STRUCTURED-FIELDS]. Each member of the list is an opaque value that identifies a group that the response belongs to.

HTTP/1.1 200 OK
Content-Type: application/javascript
Cache-Control: max-age=3600
Cache-Groups: "scripts"

The ordering of members is not significant. Unrecognised Parameters MUST be ignored.
Implementations MUST support at least 128 groups in a field value, with up to at least 128 characters in each member. Note that generic limitations on HTTP field lengths may constrain the size of this field value in practice.
Identifying Grouped Responses
Two responses stored in the same cache are considered to have the same group when all of the following conditions are met:
1. They both contain a Cache-Groups response header field that contains the same String (in any position in the List), when compared character-by-character.
2. The both share the same URI origin (per Section 4.3.1 of [HTTP]).
Cache Behaviour
Invalidation
A cache that invalidates a stored response MAY invalidate any stored responses that share groups (per Section 2.1) with that response.
Cache extensions can explicitly strengthen the requirement above. For example, a targeted cache control header field [TARGETED] might specify that caches processing it are required to invalidate such responses.
The Cache-Group-Invalidation Response Header Field
The Cache-Group-Invalidation response header field is a List of Strings [STRUCTURED-FIELDS]. Each member of the list is an opaque value that identifies a group that the response invalidates, per Section 2.2.1.
For example, a POST request that has side effects on two cache groups could indicate that stored responses associated with either or both of those groups should be invalidated with:

HTTP/1.1 200 OK
Content-Type: text/html
Cache-Group-Invalidation: "eurovision-results", "kylie-minogue"

The Cache-Group-Invalidation header field MUST be ignored on responses to requests that have a safe method (e.g., GET; see Section 9.2.1 of [HTTP]).
A cache that receives a Cache-Group-Invalidation header field on a response to an unsafe request MAY invalidate any stored responses that share groups (per Section 2.1) with any of the listed groups.
Cache extensions can explicitly strengthen the requirement above. For example, a targeted cache control header field [TARGETED] might specify that caches processing it are required to respect the Cache-Group-Invalidation signal.
The ordering of members is not significant. Unrecognised Parameters MUST be ignored.
Implementations MUST support at least 128 groups in a field value, with up to at least 128 characters in each member. Note that generic limitations on HTTP field lengths may constrain the size of this field value in practice.
IANA Considerations
IANA should perform the following tasks:
HTTP Field Names
Enter the following into the Hypertext Transfer Protocol (HTTP) Field Name Registry:
- Field Name: Cache-Groups
- Status: permanent
- Reference: RFC nnnn
- Comments:
- Field Name: Cache-Group-Invalidation
- Status: permanent
- Reference: RFC nnnn
- Comments:
Security Considerations
This mechanism allows resources that share an origin to invalidate each other. Because of this, origins that represent multiple parties (sometimes referred to as "shared hosting") might allow one party to group its resources with those of others, or to send signals which have side effects upon them.
Shared hosts that wish to mitigate these risks can control access to the header fields defined in this specification.
References
Normative References
[HTTP]

HTTP Semantics
R. Fielding, Ed.
M. Nottingham, Ed.
J. Reschke, Ed.
June 2022
STD 97
RFC 9110
DOI 10.17487/RFC9110
[HTTP-CACHING]

HTTP Caching
R. Fielding, Ed.
M. Nottingham, Ed.
J. Reschke, Ed.
June 2022
STD 98
RFC 9111
DOI 10.17487/RFC9111
[STRUCTURED-FIELDS]

Structured Field Values for HTTP
Mark Nottingham
Cloudflare
Poul-Henning Kamp
The Varnish Cache Project
21 April 2024
Internet-Draft draft-ietf-httpbis-sfbis-06
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[TARGETED]

Targeted HTTP Cache Control
S. Ludin
M. Nottingham
Y. Wu
June 2022
RFC 9213
DOI 10.17487/RFC9213
Acknowledgements
Thanks to Stephen Ludin for his review and suggestions.